(*  Delphi-Tipps
    (c) Joachim Mohr
    Stichworte: Ini-Files direkt (oder mit uses inifiles)
                Webbrowser
                Men dynamisch erzeugen mit passendem MenuHandler
                Zeile in einem Memo ermitteln
                OleObjekt erzeugen (MS-Internetexplorer)
                Eltern- und Kindfenster (cascade und tile)
                Form2aktiv (Kindfenster) aus Sender ermitteln
                Verzeichnis (teilweise) einlesen (findfirst nie ohne findclose)
                uses darf berkreuzend im Implementation-Teil vorkommen
                TComponent.Tag verwenden
                ParamCount ParamStr(0)  ParamStr(1) ... verwenden
                GetLocalIPAddress ConnectionKind
                ordnen
                clipboard.asText
                MessageBox
                Anforderungen in OnCreate werden in Destroy wieder freigegeben
                release statt free
    ------------------------------------------
    Getestet mit: Delphi 5 Professionel (Nur in Professionel: Komponente Webbrowser).
    In Delphi Standart muss Webbrowser als AktivX-Element installieren werden.
    (Delphi-Men:Komponente|AktivX importieren)
*)
(* Arbeiten mit Kindfenstern funktioniert auch folgendermaen:
var
  i                 : integer;
begin
  for i := 0 to form1.MDIChildCount - 1 do Begin
    showmessage(Form1.MDIChildren[i].Caption)
  End;
  (*// Check to see if the form is the last on MDIChildren array and
  // correct I variable
  if (i = MDIChildCount) then Dec(i);
  // I variable contains the index of the form with caption 'ccc'

  if (Pos('ccc', MDIForm.MDIChildren[i].Caption) <> 0) then
  begin
     // If the form with caption 'ccc' exists then you access data and show it
     // The following line of code is very interesting, look at the "as" clause,
     // if you have different types of MDIChild forms, you simply change
     // the type of form after the "as" clause
     // The data you want is contained on Edit1.Text
     with (MDIForm.MDIChildren[I] as TMDIChildForm).Edit1 do
       DataFromOtherForm := Text;
     ShowMessage(DataFromOtherForm);
  end;*)




unit Unit1ww;

interface

uses unit2ww, FileCtrl,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, OleServer, Outlook8, Psock, NMHttp, Word97;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    neu1: TMenuItem;
    Fenster1: TMenuItem;
    Untereinander1: TMenuItem;
    Nebeneinander1: TMenuItem;
    Beenden1: TMenuItem;
    IpAdresse1: TMenuItem;
    N2: TMenuItem;
    Hilfe1: TMenuItem;
    N3: TMenuItem;
    MSExplorer1: TMenuItem;
    Vor1: TMenuItem;
    Zurck1: TMenuItem;
    NchstelokaleDeteilesen1: TMenuItem;
    letztelokaleDateilesen1: TMenuItem;
    StatusBar1: TStatusBar;
    Zwischenablagespeichern1: TMenuItem;
    Test1: TMenuItem;
    TextderStatusleistemerken1: TMenuItem;
    gesamtenTextspeichern1: TMenuItem;
    Adresseaufrufen1: TMenuItem;
    OpenDialog1: TOpenDialog;
    kopieren1: TMenuItem;
    N1: TMenuItem;
    Drucken1: TMenuItem;
    TabControl1: TTabControl;
    AlleHTMLDateieneinesOrdnerseinlesen1: TMenuItem;
    Dateilschen1: TMenuItem;
    Dokumentspeichern1: TMenuItem;
    Schriftgradndern1: TMenuItem;
    Dokumentlokalspeichernunter1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Wordstarten1: TMenuItem;
    Suchen1: TMenuItem;
    Speicherortndern1: TMenuItem;
    alsJPEGGraphiklokalspeichern1: TMenuItem;
    procedure neu1Click(Sender: TObject);
    procedure Untereinander1Click(Sender: TObject);
    procedure Nebeneinander1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IpAdresse1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Menu1Handler(Sender: TObject);
    procedure Hilfe1Click(Sender: TObject);
    procedure MSExplorer1Click(Sender: TObject);
    procedure Zurck1Click(Sender: TObject);
    procedure Vor1Click(Sender: TObject);
    procedure NchstelokaleDeteilesen1Click(Sender: TObject);
    procedure letztelokaleDateilesen1Click(Sender: TObject);
    procedure Zwischenablagespeichern1Click(Sender: TObject);
    procedure Test1Click(Sender: TObject);
    procedure TextderStatusleistemerken1Click(Sender: TObject);
    procedure Adresseaufrufen1Click(Sender: TObject);
    procedure kopieren1Click(Sender: TObject);
    procedure Drucken1Click(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure AlleHTMLDateieneinesOrdnerseinlesen1Click(Sender: TObject);
    procedure Dateilschen1Click(Sender: TObject);
    procedure Dokumentspeichern1Click(Sender: TObject);
    procedure Schriftgradndern1Click(Sender: TObject);
    procedure Dokumentlokalspeichernunter1Click(Sender: TObject);
    procedure Wordstarten1Click(Sender: TObject);
    procedure Suchen1Click(Sender: TObject);
    procedure Fenster1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Speicherortndern1Click(Sender: TObject);
    procedure alsJPEGGraphiklokalspeichern1Click(Sender: TObject);


  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
  DateiVonFestplatte = 0;
  AlleHtmlDateien = 1;
  Lokalspeichern = 2;
  Clipboardspeichern = 3;
  magic = 999;
  AnzahlStandardmenus=2; //Im Enwurf sichtbar als 0. und 1...
  AnzahlLesezeichen=12;  //...Rest 2. bis (AnzahlLesezeichen+2). wird dynamisch aufgebaut
  MenuReihen=28;         //Untermens (nach unten) beschrnken
  historymax=30;         //Die letzten 30 Aufrufe werden gespeichert
  DateienMax=250;        //Keine endlosen Verzeichnisse einlesen
  MenuLesezeichen='Links'; //Falls Anwender keinen anderen Namen vergibt
  MenuLesezeichenAuswaehlen='Link auswhlen';   //In jedem LinkVerzeichnismenu
  MenuLesezeichenHinzufuegen='Link hinzufgen'; //In jedem LinkVerzeichnismenu
  MenuHilfe='Hilfe'; //Zunchst in jedem LinkVerzeichnismenu
  clHellBlau  =128+256*255+65536*255; //=RGB(128,255,255);
var
  stop: boolean;
  Form1: TForm1;
  dateien,               //Falls lokal hintereinander HTML-Texte gelesen werden
  history:Tstringlist;   //in Combobox erscheinen die letzten Eintrge
  lesezeichen: array[0..AnzahlLesezeichen-1] of TStringlist;
  lesezeichengeaendert: array[0..AnzahlLesezeichen-1] of boolean;
  //oder dynamisch lesezeichen: array of TStringlist;
  //mit setlength(lesezeichen,AnzahlLesezeichen);
  AlterStatusbarText:string;    //siehe neuesFenster
  Form2: array of TForm2;  //Spter entdeckt: ginge auch mit
                           //Form1.MDIChildren[i] (0<=i<form1.MDIChildCount) ...
  Ueberschrift: array of String;  //... Form1.MDIChildren[i].caption
  // ... und dann zum Beispeil with (Form1.MDIChildren[I] as TMDIChildForm).wbebrowser1 do
  TabIndexAlt: integer;
  function temphtml: string;
  procedure BaueTabcontrol;
  function frage(const titel,b1,b2,b3,b4,s:string):integer;
  function Programmname:string; //ohne exe fr .ini und .ww1 .ww2 .. -Dateien
  function char_l(const s:string; const k:integer):char; //s[k]=#0 fr k>length(s)
  procedure ErzeugeForm2Aktiv(url:string);

implementation

uses  //URLMon, fr UrlDownloadToFile
      OleCtrls,
      //SHDocVw, //Twebbrowser
      jpeg,
      MSHTML, //fr HTML
      WINSOCK,// fr IP-Adresse
      wininet, //fr InternetGetConnectedState
      clipbrd, //fr clipboard.asText
      ComObj,  //fr Ole
      activeX,
      ShellApi, //fr ShellExecute
      Unit3ww,unit4ww; //berkreuzend erlaubt (nicht im Interface-Teil

{$R *.DFM}

function INIPfad(k:integer):string;
begin
 result:=ChangeFileExt(paramstr(0),'.in'+intToStr(k));
end;




Procedure BaueTabControl;
  var k: integer;
begin
  with Form1.Tabcontrol1 do if length(form2) > 0 then Begin
    for k := 0 to length(Form2) - 1 do
      if Form2[k] = nil then BEgin //mit letzen Eintrag tauschen und verkrzen
        Form2[k] := form2[length(form2)-1];
        Ueberschrift[k] := Ueberschrift[length(form2)-1];
        setlength(form2,length(form2)-1);
        setlength(Ueberschrift,length(form2));
      ENd;
    tabs.Clear;
    for k := 0 to length(Form2) - 1 do BEgin
      tabs.Add(Ueberschrift[k]);
      if (length(form2)>4) and
        (length(tabs[k])>20) then tabs[k] := copy(tabs[k],1,20) + '..';
    ENd;
  End;
  if length(form2) = 0 then ErzeugeForm2Aktiv('');
end;

function frage(const titel,b1,b2,b3,b4,s:string):integer;
  var form4:Tform4;
begin
  form4:=Tform4.Create(form1);
  with form4 do Begin
  try
    edit1.text:=titel;
    button1.Caption:=b1;
    if b2>'' then button2.Caption:=b2 else button2.hide;
    if b3>'' then button3.Caption:=b3 else button3.hide;
    if b4>'' then button4.Caption:=b4 else button4.hide;
    memo1.Text:=s;
    showmodal;
    result:=rueckgabe0123;
  finally free end;
  End;
end;


function programmName:string;
begin
 result:=copy(paramstr(0),1,length(paramstr(0))-4); //Ohne ".exe"
end;

function temphtml: string;
var p: Pchar;
begin
  P := StrAlloc(MAX_PATH + 1);
  try GetTempPath(MAX_PATH + 1,p);
    result := p+'ttweb.html';
  finally StrDispose(P) End;
end;

function webdatei(pfad: string) :boolean;
begin //keine webdatei z.b. 'c:\ordner\test';
  result := true;
  if (char_l(pfad,2)=':') and (char_l(pfad,3)='\') and
    (ExtractFileExt(pfad) = '') then Begin
    if fileexists(temphtml) then deletefile(temphtml);
    if copyfile(Pchar(pfad),Pchar(temphtml),true) then BEgin
      FindAddress(temphtml);
      result := false;
    ENd;
  End;
end;

procedure ErzeugeForm2Aktiv(url:string);
  var k     :integer;
      form2B:TForm2;
      recycled:boolean;
begin
  form1.TabControl1.Show;
  form2B := nil;
  for k := 0 to length(form2) - 1 do
    if form2[k] <> nil then if pos('.',form1.TabControl1.Tabs[k]) = 1 then Begin
      form2B := form2[k];
      form2[k] := nil; //wird recycled: s.u.
      break;
    End;
  if form2B = nil then form2B:=Tform2.Create(Form1); //Neues Fenster
    //Das bisherige Fenster - falls schon vorhanden - bleibt (ohne Zeiger)
    //Der Zeiger ist z.B. w:=(sender as TControl).parent as TForm2;
  recycled := false;
  for k := 0 to length(form2) - 1 do
    if form2[k] = nil then Begin
    recycled := true;
    form2[k] := form2B;
    form1.tabcontrol1.TabIndex := k;
    form1.TabControl1.Tabs[k] := '.'; //intToStr(k+1);
    break;
  End;
  if not recycled then Begin
    setlength(form2,length(Form2)+1);
    setlength(ueberschrift,length(form2) + 1);
    form2[length(Form2)-1] := form2B;
    with Form1.Tabcontrol1 do BEgin
      Tabs.Add('.'); //IntToStr(length(Form2)));
      TabIndex := length(Form2) -1;
    ENd;
  End;
  with form2B do Begin
    caption:='';
    form1.Caption:='TTWEB';
    //formstyle:=fsMDIChild; (Kindfenster im Objektispector)
    ComboBox1.Align:=alTop;
    WebBrowser1.Align:=alclient;
    for k:=0 to history.count-1 do
      combobox1.items.add(history[k]);
    //form1.Cascade;
    form2B.windowstate:=wsMaximized;
    //Width:=screen.width-40;
    //height:=screen.height-40;
    form2Aktiv:=Form2B; //nicht gleich siehe TForm2.resize
    if url>'' then Begin
      form2B.ComboBox1.text:=url;
      if webdatei(url) then FindAddress(url);
    End;
  End;
  form1.Color := clBtnFace;
end;

procedure TForm1.neu1Click(Sender: TObject);
begin
 ErzeugeForm2Aktiv('');
end;

procedure TForm1.Untereinander1Click(Sender: TObject);
begin
  cascade;
end;

procedure TForm1.Nebeneinander1Click(Sender: TObject);
begin
  tile
end;

{function NurLeerzeichen(const s:string):boolean;
begin
  if s='' then result := true else
    result := (s[1]=' ') and NurLeerzeichen(copy(s,2,length(s)-1))
end;}

procedure Untermenu(const s:string);
        var Item :TMenuItem;
            x:integer;
begin
  //if NurLeerZeichen(cops) then exit;
  //Verschrft:Einrckungen sollen auch bergangen werden
  //           Diese dienen dann als Kommentare.
  if s='' then exit;
  if s[1] = ' ' then exit;
  Item:= TMenuItem.Create(Form1);
  Item.Caption :=s;
  Item.OnClick :=Form1.Menu1Handler;
  x:=form1.MainMenu1.Items.Count-1; //was gerade aufgebaut wird
  with Form1.MainMenu1.Items[x] do Begin
    Add(Item);
    if count mod MenuReihen =0 then item.Break := mbBarbreak;
    item.Tag:=x-AnzahlStandardmenus;
  End;
end;

function char_l(const s:string; const k:integer):char;
  begin if (k<=0) or (k>length(s)) then result:=' ' else
        result:=s[k]
  end;

procedure KopfMenu(j:integer); //j=items.tag von 0  bis AnzahlLesezeichen-1.
     var Item :TMenuItem;
         s    :string;
         k    :integer;
begin
  Item:= TMenuItem.Create(Form1);
  Item.OnClick:=Form1.Menu1Handler;
  //Kopfmenu
  Form1.MainMenu1.Items.Add(Item);
  //evtl. Lesezeichen fllen
  if lesezeichen[j].count=0 then Begin
    if j=0 then
    lesezeichen[j].text:=
      '          Suche'#13+
      'http://meta.rrzn.uni-hannover.de'#13+
      'http://groups.google.com'#13+
      'www.teleauskunft.de'#13+
      '       Fahrplan'#13+
      ' (Einrckungen sind Kommentare: Sie werden nicht als Men angezeigt.'+#13+
      'http://bahn.hafas.de'#13+
      'www.efa-bw.de'
  else
    lesezeichen[j].text:='     '+MenuLesezeichen+#13+
                         MenuHilfe;
  End;
  //Jetzt Menu fllen
  s:=lesezeichen[j][0];
  if pos('.',s)>0 then s:=trim(s);
  form1.MainMenu1.Items[AnzahlStandardmenus+j].caption:=trim(copy(s,1,30));//hchstens
  form1.MainMenu1.Items[AnzahlStandardmenus+j].tag := magic;  //siehe menuHandler
  //Untermenus
  Untermenu(MenuLesezeichenAuswaehlen);
  Untermenu(MenuLesezeichenHinzufuegen);
  Untermenu('-');
  k:=lesezeichen[j].Count-1;
  for k:=1 to k do untermenu(copy(lesezeichen[j][k],1,50));
end;

procedure TForm1.FormCreate(Sender: TObject);
  var k:integer;
begin
  tabcontrol1.Hide;
  form2aktiv:=nil;
  setlength(Form2,0);
  setlength(ueberschrift,0);
  tabIndexAlt := 0;
  form1.SetBounds(0,0,screen.width,screen.height);
  //formstyle:=fsMDIForm; (Als EtlernForm im Objektinspektor)
  dateien:=Tstringlist.Create;
  history:=Tstringlist.create;
  Try history.LoadFromFile(programmName+'.ini');
    Except {noch nicht vorhanden} End;
  //Lesezeichen zufgen;
  for k:=0 to AnzahlLesezeichen-1 do
    Begin lesezeichen[k]:=TStringlist.Create;
    try lesezeichen[k].LoadFromFile(programmName+'.ww'+intToStr(k)) except End;
    lesezeichengeaendert[k]:=false;
    kopfmenu(k);
  End;
  StatusBar1.SimplePanel:=true;
end;
(* oder mit uses IniFiles
function copyab(const s:string; const i:integer):string;
begin result:=copy(s,i,length(s)-i+1) end;

function nurWert(const s:string):string;
  var n:integer;
begin
  n:=pos('=',s);
  if n=0 then result:=s else result:=copyab(s,n+1);
end;
 TTWIniFile:=Tinifile.create(Programmname+'.ini');
    TRy
      TTWIniFile.ReadSectionvalues('Browser',history);
      for k:=0 to history.count-1 do
        history[k]:=nurWert(history[k]);
    FInally TTWiniFile.free ENd;
lohnt sich hier nicht *)

function User_und_GetLocalIPAddress:string; //uses  WINSOCK Fr IP-Adresse
    var p:PHostEnt;
        s:array[0..128] of char;
        p2:Pchar;
        wversionrquested:Word;
        wsaData:TWsaData;
begin
        wversionrquested:=makeword(1,1);
        wsaStartup(wversionrquested,wsaData);
        GetHostname(@s,128);
        p:=GetHostByName(@s);
        p2:=iNet_Ntoa(PInAddr(p^.h_addr_list^)^);
        result:=p2;
        wsacleanup;
end;

Function ConnectionKind :string;
var
  flags: dword;
begin
  result:='';
  if InternetGetConnectedState(@flags, 0) then
     result:='IntegrnetConnection='+intToStr(flags)+#13+
     '(MODEM/LAN/PROXY/MODEMBUSY='+IntToStr(INTERNET_CONNECTION_MODEM)+' '+
                                   IntToStr(INTERNET_CONNECTION_LAN)+' '+
                                   IntToStr(INTERNET_CONNECTION_PROXY)+' '+
                                   IntToStr(INTERNET_CONNECTION_MODEM_BUSY)+')';
end;


procedure TForm1.IPAdresse1Click(Sender: TObject);
  var ip:string;
begin
  ip:=User_und_GetLocalIPAddress;
  showmessage(ConnectionKind+#13+
      'Die Lokale IP-Adresse lautet:'+ip+#13+
      'Sie wird in die Zwischenablage kopiert und ist mit Str+V verfgbar.');
  clipboard.asText:=ip;
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
 close
end;

procedure TForm1.FormDestroy(Sender: TObject);
  var k:integer;
begin
  Form1.WindowState:=wsmaximized; //wg. Delphi-Bug (siehe Simon's FAQ)
  try history.SaveToFile(programmname+'.ini') Except {kein Schreibzugriff} End;
  dateien.Free;
  history.Free;
  for k:=0 to AnzahlLesezeichen-1 do Begin
    if lesezeichengeaendert[k]  then
      TRy lesezeichen[k].savetoFile(programmName+'.ww'+intToStr(k));
      EXcept {Kein Schreinzugriff} ENd;
      lesezeichen[k].free;
  End;
end;

function pruefeObGeaendert(const a,b:Tstrings):boolean;
  var k,n,m:integer;
begin
  result:=false;
  n:=a.Count;
  if (n>0) and (a[n-1]='') then dec(n);
  m:=b.Count;
  if (m>0) and (b[m-1]='') then dec(m);
  if n<>m then result:=true else
    for k:=0 to n-1 do
      if a[k]<>b[k] then Begin
        result:=true;
        exit;
     End;
end;



procedure ProcLesezeichenAuswaehlen(nr:integer);
begin
  with form3 do Begin
    form3Adresse:=programmName+'.ww'+intToStr(nr);
    memo1.ReadOnly:=false;
    memo1.Color:=clwhite;
    memo1.Lines.text:=lesezeichen[nr].Text;
    BSpeichern.show;
    BEinlesen.show;
    showmodal;
    if (memo1.ReadOnly) or (memo1.text='') then exit;
    if pruefeObGeaendert(memo1.Lines,lesezeichen[nr]) then BEgin
      lesezeichen[nr].text:=memo1.Lines.text;
      lesezeichengeaendert[nr]:=true;
      showmessage('Gendert. Beim nchsten Programmaufruf ist das Men angepasst.');
    ENd;
  End;
end;

function VolleAdresse(const caption:string;const nr:integer):string;
  var k:integer;
begin
  //1. Versuch
  for k:=1 to lesezeichen[nr].count-1 do //0 Ist Ordnername
    if Caption=lesezeichen[nr][k] then Begin
      result:=Caption;
      //exit;
    End;
   //2. Versuch
  for k:=1 to lesezeichen[nr].count-1 do
    if pos(Caption,lesezeichen[nr][k])=1 then Begin
      result:=lesezeichen[nr][k]; 
      exit;;
    End;
  result:=Caption; //lesezeichen existiert nur noch im Menu
end;

procedure ProcLesezeichenHinzufuegen(nr:integer);
begin
 if form2aktiv=nil then showmessage('Erst "Neu" whlen und dann Lesezeichen eintragen!') else
 Begin
   lesezeichen[nr].add(form2aktiv.combobox1.text);
   lesezeichengeaendert[nr]:=true;
   showmessage('Dem Lesezeichenordner '+ lesezeichen[nr][0]+' wurde hinzugefgt:'#13+
               form2aktiv.combobox1.text+#13+
               'Sie knnen mit "Lesezeichen auswhlen" einen Kommentar hinzufgen'#13+
               'oder die Reihenfolge ndern.'#13+
               'Beim nchsten Programmaufruf ist das Men angepasst!');
 End;
end;

procedure TForm1.Menu1Handler(Sender: TObject);
   var s:string;
       nr:integer;
begin
     with Sender as TMenuItem do Begin
       nr:=tag; //tag bezieht sich auf (sender as TMenuItem).tag
       if nr = magic then exit;
       s:=caption;
       if s=MenuLesezeichenAuswaehlen  then ProcLesezeichenAuswaehlen(nr) else
       if s=MenuLesezeichenHinzufuegen then ProcLesezeichenHinzufuegen(nr) else
       BEgin
         if s=MenuHilfe then form1.Hilfe1Click(Nil) else
           if pos(' ',caption)<>1 then BEGin //keine Webadresse
             ErzeugeForm2Aktiv('');
             form2aktiv.ComboBox1.text:=VolleAdresse(caption,nr);
             FindAddress(form2aktiv.ComboBox1.text);
           END;
       ENd;
     End;
end;

{function DownloadFile(SourceFile, DestFile: string): Boolean;
begin
  try
    Result :=  UrlDownloadToFile(nil, PChar(SourceFile),
               PChar(DestFile), 0, nil) = 0;
  except Result := False; end;
end;

procedure testdownload;  funzt
const
  // URL Location
  SourceFile = 'http://home.t-online.de/home/Joachim_Mohr/download.html';
  // Where to save the file
  DestFile   = 'c:\ddd\test.html';
begin
  if DownloadFile(SourceFile, DestFile) then
  begin
    ShowMessage('Download succesful!');
    // Show downloaded image in your browser
    ShellExecute(Application.Handle,PChar('open'),PChar(DestFile),
    PChar(''),nil,SW_NORMAL)
  end
  else
    ShowMessage('Error while downloading ' + SourceFile)
end;}

procedure test;
begin
end;


procedure TForm1.Hilfe1Click(Sender: TObject);
begin with Form3 do Begin
  //test; exit;
  Memo1.color:=clHellBlau;
  Memo1.text:=
     'Die nicht eingerckten Lesezeichen erscheinen im Men.'#13#10+
     'Klicken Sie dann im Schreibfeld das gewnschte Lesezeichen an!'#13#10+
     'Die Lesezeichen knnen hier auch bearbeitet werden'#13#10+
     '1. weitere Lesezeichen eintragen!'#13#10+
     '2. Den Ordnernamen (die erste Zeile) ndern.'#13#10+
     '3. Kommentare einfgen (Kommentare sind die eingerckte Zeilen).'#13#10+
     '4. ber "Fenster" ist diese Hilfe stets zu erreichen.)'#13#10+
     'Sie knnen Ihre Lesezeichen auf einem anderen Computer durch Kopieren'#13#10+
     'der Dateien "ttweb.ww0", "ttweb.ww1", ... bernehmen.'#13#10+
     '----------------------------------------------------'#13#10+
     'Drucken oder hnliches knnen Sie mit Klick auf die rechte Maustaste '#13#10+
     'oder ber Men "Fenster|MSExplorer"'#13#10+
     'Damit rufen Sie den Internetexplorer mit derselben Adresse auf.'#13#10#13#10+
     '               (c) Joachim_Mohr@t-online.de'#13#10+
     'Homepage:'#13#10+
     'http://delphi-zsg-rottenburg.de'#13#10+
     'http://home.t-online.de/home/Joachim_Mohr'#13#10#13#10+
     'Letzte nderung: 11.11.2001 Ausgewhltes wird besser kopiert.'#13#10+
     '                            Bis zu 100 Links pro. Men mglich.'#13#10+
     '                 30.11.2001 Registerkarten fr Fenster';
  if not visible then showmodal;
End end;

procedure NavigierenMs18(url:string); //MicrosoftExplorer
  var e:OleVariant;
Begin
  try e:=CreateOleObject('InternetExplorer.Application'); //uses ComObj
  Except showmessage('Internetexplorer nicht installiert'); exit; End;
  try
    e.visible:=true;
    e.top:=0;
    e.left:=0;
    e.width:=screen.width;
    e.height:=screen.height;
    if url>'' then e.Navigate(url);
  except showmessage('Ms-Explorer streikt!'); End;
End;

procedure TForm1.MSExplorer1Click(Sender: TObject);
begin
  if form2aktiv=nil then NavigierenMs18('') else
     NavigierenMs18(form2aktiv.ComboBox1.Text);
end;

procedure TForm1.Zurck1Click(Sender: TObject);
begin
   if form2aktiv=nil then exit;
   try form2Aktiv.webbrowser1.goBack except showmessage('Anfang erreicht') End;
end;

procedure TForm1.Vor1Click(Sender: TObject);
begin
 if form2aktiv=nil then exit;
 try form2Aktiv.webbrowser1.goForward except showmessage('Ende erreicht') End;
end;

function istBrowserfaehig(const pfad:string):boolean;
  var ext:string;
begin
  ext:=lowercase(extractfileext(pfad));
  result:=(pos('.htm',ext)=1) or (ext='.gif') or (ext='.jpg');
end;

function Rueckfrage:boolean;
begin
  if Application.MessageBox('Soll das Verzeichnis weiter eingelesen werden?',
                            'Verzeichnis ist sehr gro',
                            MB_YesNo+MB_IconQuestion+MB_DEFBUTTON2)
     =IDYes then result:=true else result:=false;
end;

function ii(const s:string):integer; //Tolerante IntToStr
  const ziff0=ord('0');
  var k:integer;
begin
  result:=0;
  for k:=1 to length(s) do
    if s[k] in ['0'..'9'] then result:=10*result+ord(s[k])-ord(ziff0);
end;


function copyab(const s:string; const i:integer):string;
begin result:=copy(s,i,length(s)-i+1) end;

FUNCTION kleiner_str(s,t: string; b:char): boolean; var j:integer; a,z:char;
       var iis,iit:integer;    //b=n numerisch d:Duden a:alphabetisch
    procedure c(var x:char);
      begin Case x of '': x:='A';
                      '': x:='O';
                      '': x:='U'
            End
      end;
 begin
   if b='n' then Begin
   iis:=ii(s);
   iit:=ii(t);
     if iis<>iit then
       result:=(ii(s)<ii(t))
       else kleiner_str:=(s<t) //alphabetische wg. 2. Prioritt
   End
   else Begin
   s:=AnsiUpperCase(s);
   t:=AnsiUpperCase(t);
   if pos('',s)>0 then s:=copy(s,1,pos('',s)-1)+'SS'+copyab(s,pos('',s)+1);
   if pos('',t)>0 then t:=copy(t,1,pos('',t)-1)+'SS'+copyab(t,pos('',t)+1);
   if b='a' then BEgin //Alphabetisch =ae etc.
     if pos('',s)>0 then s:=copy(s,1,pos('',s)-1)+'AE'+copyab(s,pos('',s)+1);
     if pos('',s)>0 then s:=copy(s,1,pos('',s)-1)+'OE'+copyab(s,pos('',s)+1);
     if pos('',s)>0 then s:=copy(s,1,pos('',s)-1)+'UE'+copyab(s,pos('',s)+1);
     if pos('',t)>0 then t:=copy(t,1,pos('',t)-1)+'AE'+copyab(t,pos('',t)+1);
     if pos('',t)>0 then t:=copy(t,1,pos('',t)-1)+'OE'+copyab(t,pos('',t)+1);
     if pos('',t)>0 then t:=copy(t,1,pos('',t)-1)+'UE'+copyab(t,pos('',t)+1);
   ENd else Begin //ordnen nach Duden =a
     if pos('',s)>0 then s:=copy(s,1,pos('',s)-1)+'A'+copyab(s,pos('',s)+1);
     if pos('',s)>0 then s:=copy(s,1,pos('',s)-1)+'O'+copyab(s,pos('',s)+1);
     if pos('',s)>0 then s:=copy(s,1,pos('',s)-1)+'U'+copyab(s,pos('',s)+1);
     if pos('',t)>0 then t:=copy(t,1,pos('',t)-1)+'A'+copyab(t,pos('',t)+1);
     if pos('',t)>0 then t:=copy(t,1,pos('',t)-1)+'O'+copyab(t,pos('',t)+1);
     if pos('',t)>0 then t:=copy(t,1,pos('',t)-1)+'U'+copyab(t,pos('',t)+1);
   ENd;
   j:=0; repeat j:=succ(j); a:=char_l(s,j); z:=char_l(t,j);
   c(a); c(z) until (a<>z) or (j>=length(t)); kleiner_str:=(a<z) End end;

procedure stringtausch(var i,k:string); //lokal
      var x:string;
  begin x:=i;
        i:=k;
        k:=x
  end;

PROCEDURE ordneAr(var x:array of string;von,bis:integer;stelle1,stelle2:integer;
                  MitBeruecksichtigungDergrossSchreibung:boolean);
       //geordnet wird von "von"  bis "bis"
       //Stelle1=0: Ordnung der ganzen Strings
        var i,j,p:integer;
    function kleiner(a,b:integer):boolean;                   //statt x[a]<x[b]
      begin if Stelle1=0 then Begin
              if MitBeruecksichtigungDergrossSchreibung then
                result:=kleiner_str(x[a],x[b],'d') {mit ...} else
                  result:=kleiner_str(AnsiUppercase(x[a]),AnsiUpperCase(x[b]),'d') {ohne Groschreibung}
            End else Begin
              if MitBeruecksichtigungDergrossSchreibung then
                result:=kleiner_str(copy(x[a],Stelle1,Stelle2),copy(x[b],Stelle1,Stelle2),'d') {mit ...}
                  else result:=kleiner_str(AnsiUppercase(copy(x[a],Stelle1,Stelle2)),
                       AnsiUpperCase(copy(x[b],Stelle1,Stelle2)),'d') {ohne Groschreibung}
            End;
      end;
 begin
   p:=bis;
   while p>1 do Begin
     p:=p div 2;
     i:=von;
     repeat
       if kleiner(i+p,i) then BEgin
         stringtausch(x[i],x[i+p]); //(Schreibe normale Tauschprozedur!)
         j:=i;
         while j-p>=1 do BEGin
           if kleiner(j,j-p) then bEgin
             stringtausch(x[j],x[j-p]);
             j:=pred(j)
           eNd  else j:=0;
         END;
       ENd;
       i:=succ(i)
     until i+p>bis
   End;
 end;

procedure OrdneStringlistmitEntfernen(var aa:Tstringlist);
  var bb:array of string;
      var k:integer;
begin
  setlength(bb,aa.count);
  for k:=0 to aa.count-1 do bb[k]:=aa[k];
  ordneAr(bb,0,aa.count-1,0,0,false);
  aa.Clear;
  for k:=0 to length(bb)-1 do if bb[k]>'' then aa.Add(bb[k]);
end;

procedure DateienEinlesen;
  var   SR:TSearchrec;
      pfad:string;
      erg,n:integer;
      weiterlesen:boolean;
begin
  weiterlesen:=true;
  if Form2Aktiv=nil then exit;
  form2aktiv.windowstate:=wsmaximized;
  pfad:=ExtractFilePath(form2Aktiv.ComboBox1.Text);//mit '\'
  dateien.Add(form2Aktiv.ComboBox1.Text);
  erg:=findfirst(pfad+'*.*',faDirectory ,sr);
  n:=0;
  try
    while (erg=0) and weiterlesen do Begin
      if istBrowserfaehig(sr.name) then BEgin
        inc(n);
        if (n mod DateienMax)=0 then weiterlesen:=Rueckfrage;
        dateien.Add(pfad+sr.name);
      ENd;
      erg:=findnext(sr);
   End;
  OrdneStringlistmitEntfernen(Dateien);
  finally FindClose(sr) End;
end;

procedure TForm1.NchstelokaleDeteilesen1Click(Sender: TObject);
  var k:integer;
begin
  if Form2Aktiv=nil then exit;
  if dateien.Count=0 then DateienEinlesen;
  for k:=0 to dateien.Count-2 do
    if trim(AnsiLowerCase(form2aktiv.ComboBox1.text))=AnsiLowerCase(dateien[k]) then
      Begin if dateien[k]=dateien[k+1] then
          findaddress(dateien[k+2]) else findaddress(dateien[k+1]);
        exit;
      End;
  showmessage('Ende erreicht. Beginne von vorne');
  findaddress(dateien[0]);
end;

procedure TForm1.letztelokaleDateilesen1Click(Sender: TObject);
  var k:integer;
begin
  if Form2Aktiv=nil then exit;
  if dateien.Count=0 then DateienEinlesen;
  for k:=1 to dateien.Count-1 do
    if AnsiLowerCase(form2aktiv.ComboBox1.text)=AnsiLowerCase(dateien[k]) then
      Begin
        findaddress(dateien[k-1]);
        exit;
      End;
  showmessage('Anfang erreicht. Gehe zum Ende');
  findaddress(dateien[dateien.count-1]);
end;

function GesamterText:string;
    var  Doc: IHTMLDocument2;
         Body: IHTMLBodyElement;
         TextRange: IHTMLTxtRange;
begin
  try
    Doc:= Form2aktiv.WebBrowser1.Document as IHTMLDocument2;
    Body:= Doc.body as IHTMLBodyElement;
    TextRange:= Body.createTextRange;
    result:= TextRange.text;
  except result:= EmptyStr end;
end;


function MarkierterText:string;
var
  Doc: IHTMLDocument2;
  Selection: IHTMLSelectionObject;
  TextRange: IHTMLTxtRange;
begin
  try
    Doc:=Form2Aktiv.WebBrowser1.Document as IHTMLDocument2;
    Selection:= Doc.selection;
    TextRange:= Selection.createRange as IHTMLTxtRange;
    result:= TextRange.text;
  except
    result:= EmptyStr;
  end;
end;

function OrdnerfuerText: string;
 var pu:tstringlist;
begin
  result := '';
  pu:=Tstringlist.create;
  try
    try pu.LoadFromFile(IniPfad(Clipboardspeichern));
      Except {noch nicht vorhanden} End;
    if pu.count>0 then result := pu[0];
  finally
    pu.free;
    if result = '' then result := extractFilepath(ParamStr(0));
    result := IncludeTrailingBackslash(result);
  End;
end;



procedure TForm1.Zwischenablagespeichern1Click(Sender: TObject);
  var dateiname:string;
      pu:Tstringlist;
begin
  pu:=Tstringlist.Create;
  try
    if sender=gesamtenTextspeichern1 then
      pu.text:=GesamterText else pu.text:=MarkierterText;
    if pu.text='' then pu.text:=clipboard.AsText;
    if frage('Auf Festplatte Text speichern','ja','nein','','',
              copy(pu.text,1,500)+'...')=0 then Begin
      dateiname:=OrdnerfuerText + FormatDateTime('mmddhhnn',Now)+'.clb';
      pu.SaveToFile(dateiname);
      showmessage('Zwischenablage gespeichert in Datei:'#13+
                 dateiname);
    End;
  finally pu.Free End;
end;

procedure TForm1.Test1Click(Sender: TObject);
begin
  ErzeugeForm2Aktiv(form2aktiv.ComboBox1.text);
end;

procedure TForm1.TextderStatusleistemerken1Click(Sender: TObject);
begin
  with form1.StatusBar1 do
    if simpletext<>'' then NeueUrl(SimpleText);
end;

(*procedure TForm1.AlsTextdateizeigen1Click(Sender: TObject);
  var  V:OleVariant;
       pfad,temppfad:string;
       k,code,z:integer;
       lines:Tstringlist;
       f:Textfile;
  procedure writeln0(const s:string);
      var k:integer;
    begin
      if length(s)>=80 then Begin
        k:=80;
        while (s[k]<>' ') and (k<40) do dec(k); //i.A. jetzts[k]=' ';
        writeln(f,copy(s,1,k));
        writeln0(copyab(s,k+1)); //rekursiv
      End else writeln(f,s);
    end;
begin
  if form2aktiv=nil then exit;
  pfad:=form2aktiv.combobox1.text;
  Try V:=GetActiveOleObject('Word.Basic') except  //uses ComObj
    TRy V:= CreateOleObject('Word.Basic') except
      showmessage('Word steht nicht zur Verfgung:');
      exit;
    ENd;
  End;
  //try v.appmaximize except end;
  try v.apphide Except End;//v.appshow;
  try V.FileOpen(Name:=pfad) except {funzt trotzdem}  End;
  temppfad:=extractFilepath(ParamStr(0))+FormatDateTime('mmddhhnn',Now)+'.clb';
  code:=3; //Fr Textdateien
  try V.FileSaveAs(Name:=temppfad,format:=code); //Als txt oder rtf speichern tmp
     except {funzt trotzdem} End;
  v.apphide;
  V.FileClose;
  v:=unassigned;
  lines:=Tstringlist.Create;
  try
    Lines.LoadFromFile(temppfad);
    //Prfe ob Zeilen zu kurz
    assignFile(f,temppfad);
    rewrite(f);
    z:=0;
    for k:=0 to lines.count-2 do
      if lines[k]<>'' then
        if (length(lines[k])<10) and (length(lines[k+1])<10) then Begin
             z:=z+length(lines[k]);
             if z+length(lines[k+1])<80 then write(f,lines[k]) else BEgin
               writeln(f,lines[k]);
               z:=0;
             ENd;
        End else Begin
          z:=0;
          writeln0(lines[k]);
        End;
    writeln0(lines[lines.count-1]);
    closeFile(f);
    if ShellExecute(application.handle,
                  Pchar('open'),
                  Pchar('notepad'),
                  Pchar(temppfad),
                  Pchar(''),
                  sw_ShowNormal)>=32 then {sichtbar};
  finally lines.Free End;

end;*)

procedure TForm1.Adresseaufrufen1Click(Sender: TObject);
  var pu:Tstringlist; //zu aufwndig TIniFile
      pfad:string;
      k: integer;
begin
  pu:=Tstringlist.create;
  try
    try pu.LoadFromFile(IniPfad(DateiVonFestplatte));
      Except {noch nicht vorhanden} End;
    if pu.count>0 then pfad:=pu[0] else pfad := '';; //ReadString(Section,Schluessel,default)
    with  opendialog1 do Begin
      options:=[ofFileMustExist,ofAllowMultiselect,ofHideReadOnly,ofShareAware,
                  ofEnableSizing,{ofShowHelp,}
                  {ofOldStyleDialog,}ofNoTestFileCreate,ofNoValidate];
      //FIlter :='Alle Dateien ( *.* )|*.*';
      Initialdir:=extractFilepath(trim(pfad));
      filename:=ExtractFileName(pfad);
      if Execute then Begin
         ErzeugeForm2Aktiv(filename);
         sleep(10);
         application.ProcessMessages; //Ontitlechance bentigt Zeit
        pu.Text:=filename;
        pu.SaveToFile(Inipfad(DateiVonFestplatte));
        if files.Count > 1 then for k :=0 to files.count-1 do
        if files[k]<>filename then BEgin
           ErzeugeForm2Aktiv(files[k]);
           sleep(10);
           application.ProcessMessages;
        ENd;
      End;
    End;
   finally pu.Free End;
end;

procedure TForm1.kopieren1Click(Sender: TObject);
begin
  clipboard.AsText:=MarkierterText;
end;


procedure TForm1.Drucken1Click(Sender: TObject);
  var x: Olevariant;
begin
  form2aktiv.WebBrowser1.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_PROMPTUSER, x, x)
end;
(* Oder
var
  HTMLDoc: IHTMLDocument2;
  HTMLWnd: IHTMLWindow2;
  HTMLWindow3: IHTMLWindow3;
begin
  if form2aktiv=nil then exit;
  HTMLDoc :=Form2aktiv.webbrowser1.Document as IHTMLDocument2;
  if HTMLDoc = nil then
    raise Exception.Create('Couldn''t convert the WebBrowser to an IHTMLDocument2');
  HTMLWnd := HTMLDoc.parentWindow;
  HTMLWindow3 := HTMLWnd as IHTMLWindow3;
  // Finally, we get to the print method
  HTMLWindow3.print;
end;*


(*procedure TForm1.ZeigealsWorddokument1Click(Sender: TObject);
begin
end;

    var Filetyp,inpfad, auspfad: Olevariant;
begin
  WordApplication1.Connect;
  try
    // Hiermit wird das Word Formular sichtbar (ntzlich fr Debugging :)
    WordApplication1.Visible := True;
    inpfad := form2aktiv.ComboBox1.Text;
    WordApplication1.Documents.Open(inpfad,
      EmptyParam, EmptyParam,
      EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam,
      EmptyParam);
    WordDocument1.ConnectTo(WordApplication1.ActiveDocument);
    {Filetyp := wdFormatText;
    auspfad := ...;
    WordDocument1.SaveAs(auspfad,Filetyp);
    WordDocument1.Close;
    WordDocument1.Disconnect;}
  Finally
    //WordApplication1.Disconnect;
    //WordApplication1.Quit;
  End;
end;*)

procedure TForm1.TabControl1Change(Sender: TObject);
  var nr: integer;
begin
  {for nr := 0 to length(form2)-1 do
    if form2[nr] = nil then showmessage(IntToStr(nr)+'nil') else
       showmessage(IntToStr(nr)+'not nil');}
  nr := tabcontrol1.TabIndex;
  if form2[nr] <> nil then Begin
    form2[nr].BringToFront;
    form2aktiv := form2[nr];
    tabIndexAlt := nr;
    form1.Caption := ueberschrift[nr];
    exit;
  End;
  Tabcontrol1.TabIndex := TabIndexAlt;
end;

procedure TForm1.AlleHTMLDateieneinesOrdnerseinlesen1Click(Sender: TObject);
    var pu:Tstringlist; //zu aufwndig TIniFile
        pfad:string;
        k: integer;
        antwort:word;
  procedure VerzeichnisEinlesen(dir:string); //pfad nach pu
    var SR: TSearchRec;
  begin
    if dir[length(dir)]<>'\' then dir:=dir+'\';
    pu.Clear;
    if FindFirst(dir+'*.*',faAnyFile,SR)=0 then Begin
      repeat
        if pos('.htm',lowercase(sr.name))>0 then pu.add(dir+sr.name);
      until FindNext(SR)<>0;
      FindClose(SR); //Nach jedem findfirst ntig, um sr freizugeben!
    End;
  end;
begin
  pu:=Tstringlist.create;
  try
    try pu.LoadFromFile(IniPfad(AlleHtmlDateien));
      Except {noch nicht vorhanden} End;
    if pu.count>0 then pfad:=pu[0] else pfad := '';
    if not SelectDirectory(pfad,[],0) then exit;
    pu.Text:=pfad;
    pu.SaveToFile(Inipfad(AlleHtmlDateien));
    VerzeichnisEinlesen(pfad);
    Antwort := mrYes;
    stop := false;
    for k := 0 to pu.Count - 1 do Begin
      if stop then exit;
      if antwort <> mrAll then
        antwort := MessageDlg('Datei'+#13+pu[k]+#13'einlesen?',
                    mtConfirmation, [mbYes, mbNo, mball, mbCancel],0);
      if antwort = mrCancel then exit;
      if antwort in [mrYes, mrAll] then Begin //showmessage(intToStr(k));
        ErzeugeForm2Aktiv(pu[k]);
        if antwort = mrAll then sleep(500);
        application.ProcessMessages;
      End;
    End;
  finally pu.Free End;
end;

procedure TForm1.Dateilschen1Click(Sender: TObject);
  var k:integer;
begin
  for k := 0 to length(form2) - 1 do
    if form2[k] = form2aktiv then
       if MessageDlg('Datei'+#13+form2aktiv.urlgelesen+#13'lschen',
         mtConfirmation, [mbYes, mbNo, mbCancel],0) = mrYes then
         if not deleteFile(form2aktiv.urlgelesen)
           then showmessage('Datei nicht gelscht');
end;

procedure TForm1.Dokumentspeichern1Click(Sender: TObject);
var
 HTMLDocument: IHTMLDocument2;
 PersistFile: IPersistFile;
 dateiname: string;
begin
  dateiname:=OrdnerfuerText + FormatDateTime('mmddhhnn',Now)+
      copy(form1.caption,1,5)+'.html';
  HTMLDocument := form2aktiv.WebBrowser1.Document as IHTMLDocument2;
  PersistFile := HTMLDocument as IPersistFile;
  PersistFile.Save(StringToOleStr(Dateiname), System.True);
  showmessage('Datei gespeichert als:'#13+
               Dateiname);
end;


procedure TForm1.Schriftgradndern1Click(Sender: TObject);
begin
  showmessage('Es wird umgeschaltet in den Microsoft Internetexplorer.'#13+
  'ndern Sie den Schriftgrad dort mit Men "Ansicht" und starte TTWeb erneut');
  MSExplorer1Click(nil);
end;

procedure TForm1.Dokumentlokalspeichernunter1Click(Sender: TObject);
  var pu:Tstringlist;
     HTMLDocument: IHTMLDocument2;
     PersistFile: IPersistFile;
     dateiname: string;
begin
  pu:=Tstringlist.create;
  try
    try pu.LoadFromFile(IniPfad(Lokalspeichern));
      Except {noch nicht vorhanden} End;
    if pu.count>0 then dateiname:=pu[0] else dateiname := ''; //ReadString(Section,Schluessel,default)
    with  savedialog1 do Begin
      options:=[ofFileMustExist,ofAllowMultiselect,ofHideReadOnly,ofShareAware,
                  ofEnableSizing,{ofShowHelp,}
                  {ofOldStyleDialog,}ofNoTestFileCreate,ofNoValidate];
      Filter :='HTML-Dateien (*.html; *.htm)|*.html;*.htm|'
               +'Alle Dateien (*.*)|*.*';
      DefaultExt:='html';
      Initialdir:=extractFilepath(trim(dateiname));
      filename:=extractfilename(trim(Dateiname));
      if execute then BEgin 
        HTMLDocument := form2aktiv.WebBrowser1.Document as IHTMLDocument2;
        PersistFile := HTMLDocument as IPersistFile;
        PersistFile.Save(StringToOleStr(filename), System.True);
      pu.text := filename;
      pu.SaveToFile(IniPfad(Lokalspeichern));
      showmessage('Datei gespeichert als:'#13+
               filename);
      ENd;
    End;
  Finally pu.Free End;
end;

procedure TForm1.Wordstarten1Click(Sender: TObject);
var V: OleVariant;
begin
  Try V := GetActiveOleObject('Word.Basic')except
    TRy V := CreateOleObject('Word.Basic')except
      showmessage('Word steht nicht zur Verfgung:');
      exit;
    ENd;
  End;
  v.FileNewDefault;
  try
    v.AppMaximize;
    v.DocMaximize;
  Except End; //Nicht lebensnotwendig
  v.appshow;
  try v.ToolsOptionsSpelling(AutomaticSpellChecking := 1); except End;
end;

procedure TForm1.Suchen1Click(Sender: TObject);
const
  HTMLID_FIND       = 1;
  HTMLID_VIEWSOURCE = 2;
  HTMLID_OPTIONS    = 3;
  CGID_WebBrowser: TGUID = '{ED016940-BD5B-11cf-BA4E-00C04FD70816}';
var
  CmdTarget : IOleCommandTarget;
  vaIn, vaOut: OleVariant;
  PtrGUID: PGUID;
begin
  New(PtrGUID);
  PtrGUID^ := CGID_WebBrowser;
  if Form2aktiv.WebBrowser1.Document <> nil then
    try
      Form2aktiv.WebBrowser1.Document.QueryInterface(IOleCommandTarget, CmdTarget);
      if CmdTarget <> nil then
        try
          CmdTarget.Exec( PtrGUID, HTMLID_FIND, 0, vaIn, vaOut);
        finally
          CmdTarget._Release;
        end;
    except
      // Nothing
    end;
  Dispose(PtrGUID);
end;


procedure TForm1.Fenster1Click(Sender: TObject);
begin
  stop := true;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then Zurck1Click(Nil);
end;


procedure TForm1.Speicherortndern1Click(Sender: TObject);
  var pu:tstringlist;
      s,pfad: string;
begin
  pu:=Tstringlist.create;
  try
    try pu.LoadFromFile(IniPfad(Clipboardspeichern));
      Except {noch nicht vorhanden} End;
    if pu.count>0 then s:='Bisher:' + pu[0] else s := '';
  if  SelectDirectory('Whlen Sie ein Verzeichnis aus, '+
        'indem der Text gespeichert werden soll. ' + s,'', pfad) then Begin
    pu.text := pfad;
    pu.SaveToFile(IniPfad(Clipboardspeichern));
  End else showmessage('Abbruch');
  finally pu.free End;
end;

function ScreenShot(x, y ,Width, Height: integer; bm: TBitMap):boolean;
var
  dc: HDC;
  lpPal : PLOGPALETTE;
begin
 {Hhe und Breite testen}
  result := false;
  if ((Width <= 0) OR
      (Height <= 0)) then begin
    result := true;
    exit;
  end;
  bm.Width := Width;
  bm.Height := Height;
 {ScreenDC holen}
  dc := GetDc(0);
  if (dc = 0) then begin
    result := true;
    exit;
  end;
  if (GetDeviceCaps(dc, RASTERCAPS) AND
      RC_PALETTE = RC_PALETTE) then begin
    GetMem(lpPal, sizeof(TLOGPALETTE) +
           (255 * sizeof(TPALETTEENTRY)));
    FillChar(lpPal^, sizeof(TLOGPALETTE) +
             (255 * sizeof(TPALETTEENTRY)), #0);
    lpPal^.palVersion := $300;
    lpPal^.palNumEntries :=GetSystemPaletteEntries(dc,
       0, 256, lpPal^.palPalEntry);
    if (lpPal^.PalNumEntries <> 0) then begin
      bm.Palette := CreatePalette(lpPal^);
    end;
    FreeMem(lpPal, sizeof(TLOGPALETTE) +
            (255 * sizeof(TPALETTEENTRY)));
  end;
  BitBlt(bm.Canvas.Handle, 0, 0, Width, Height, Dc, x, y, SRCCOPY);
  ReleaseDc(0, dc);
end;



procedure TForm1.alsJPEGGraphiklokalspeichern1Click(Sender: TObject);
 var bm : TBitMap;
    jpg :TJPEGImage; //uses jpeg;
begin
  bm := Tbitmap.Create;
  jpg:=TJPEGImage.Create;
  try
    with form2aktiv.WebBrowser1 do
       ScreenShot(5,55,screen.Width - 10,screen.Height - 55,bm);
    jpg.Assign(bm);
    jpg.CompressionQuality := 50;
    jpg.Compress;
    with SaveDialog1 do Begin
     Options:=[ofCreatePrompt,ofEnableSizing,ofHideReadOnly,ofShareAware,ofEnableSizing]; //Ohne Kstchen
     Filter :='JPG-Dateien (*.jpg)';
     DefaultExt:='jpg';
     if execute then Begin
       jpg.SaveToFile(Savedialog1.Filename);
     End else showmessage('Nicht gespeichert');
   End;
  finally bm.Free; jpg.Free End;
end;

end.


