{ Eine selbstgeschriebene inputbox.
  ok       :Nur die Ausgabe einer Nachricht.
  jminput1 :Eingabe in einem Feld mit Platz fr einen langen Kommentar
  jmmnput2 :Eingabe in zwei Feldern mit Platz fr einen langen Kommentar
  --------------------------
  Rckgabewer true ("OK") und false ("Abbrechen") ber provate Vraible ok:boolean

  Stichworte: Form zur Laufzeit erzeugen
              showmodal


}

unit UnitInput;
//in "Projekt|Optionen|Formulare" Form9 zu "verfgbare Formulare" schieben!


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm15 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    BOk: TButton;
    BAbbrechen: TButton;
    procedure BOkClick(Sender: TObject);
    procedure BAbbrechenClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    OK:boolean;
    Buttons: array of TButton;
    ButtonsNr:integer;
  public
    { Public-Deklarationen }
  end;

var form15:TForm15;


function  okf(const s:string):boolean; //=false, falls "Abbrechen geklickt"
procedure okp(const s:string);
procedure oktest(const s:string); overload;
procedure oktest(const r:Extended); overload;
//Ausdruck nur zu Testzwecken fr Programmierer zum besseren Auffinden und lschen

function jminput1(const caption,ueberschrift,Erlaeuterung:string;
                  var eing:string):boolean;
function jminput2(const caption,ueberschrift1,ueberschrift2,Erlaeuterung:string;
                   var eing1,eing2:string):boolean;
function jmdialog(Const ueberschrift,Erlaeuterung,Beschriftung:string):integer;

implementation
  uses jmhilf,jmmath, UnitGeo;

{$R *.DFM}

procedure TextinMemo(const s:string); //vor showmodal
   var k,z:integer;
begin
  with form15 do Begin
    if s='' then BEgin
      height:=height-memo1.height;
      memo1.Hide;
    ENd else BEgin
      memo1.Show;
      memo1.text:=AdjustLineBreaks(s);
    ENd;
    //Zeilen zhlen
    z:=0;
    for k:=1 to length(s) do if s[k]=#13 then inc(z);
    font.size:=10; //Sicherstellen, dass positiv
    height:=height+Form15.memo1.Font.size*z*2;
    if length(s)>720 then height:=screen.Height;
    top:=(screen.Height-height) div 2;
    left:=(screen.width-width) div 2;
  End;
end;

function ok(const s:string;AbbrechenSichtbar:boolean):boolean;
begin
  form15:=Tform15.Create(Form9);
  try
  with form15 do Begin
    bok.show;
    if AbbrechenSichtbar then bAbbrechen.hide else bAbbrechen.show;
    label1.hide;
    edit1.hide;
    label2.hide;
    edit2.hide;
    memo1.top:=bok.top+bOk.height+20;
    height:=memo1.top+memo1.height+50;
    memo1.height:=height-memo1.top-40;
    caption:='Hinweis';
    TextinMemo(s);
    showmodal;
    result:=Ok;
  End;
  Finally form15.Free End;
end;

function jmdialog(Const ueberschrift,Erlaeuterung,Beschriftung:string):integer;
  var n:integer;
      wort:string;
begin
  form15:=Tform15.Create(Form9);
  try
  with form15 do Begin
    bok.hide; //An diese Stelle die buttons
    n:=0;
    repeat
      wort:=wort_n(Beschriftung,n+1);
      if wort>'' then BEgin
        setlength(buttons,n+1);
        buttons[n]:=Tbutton.Create(Nil);
        buttons[n].parent:=Form15;
        buttons[n].top:=bok.Top;
        buttons[n].height:=Bok.Height;
        if n=0 then buttons[n].left:=bok.Left else
          buttons[n].left:=buttons[n-1].left+buttons[n-1].width+10;
        buttons[n].Width:=max(length(wort)*10,50);
        buttons[n].caption:=wort;
        buttons[n].OnClick:=Form15.Bok.OnClick;
        inc(n);
      ENd;
      bAbbrechen.Hide;
      {bAbbrechen.show;
      bAbbrechen.left:=buttons[n-1].left+buttons[n-1].width+10;}
    until wort='';
    label1.hide;
    edit1.hide;
    label2.hide;
    edit2.hide;
    memo1.top:=bok.top+bOk.height+20;
    height:=memo1.top+memo1.height+50;
    memo1.height:=height-memo1.top-40;
    caption:=ueberschrift;
    TextinMemo(Erlaeuterung);
    showmodal;
    if not ok then result:=-1 else result:=ButtonsNr;
  End;
  Finally form15.Free End;
end;




function okf(const s:string):boolean;
begin result:=ok(s,true) end;

procedure okp(const s:string);
begin
  if ok(s,false) then {garnichts};
end;
procedure oktest(const s:string); overload;
begin okp(s) end;

procedure oktest(const r:Extended); overload;
begin okp(FloatToStr(r)) end;


function jminput1(const caption,ueberschrift,Erlaeuterung:string;var eing:string):boolean;
begin
  form15:=Tform15.Create(Form9);
  try
  if caption='' then Form15.caption:='Eingabe' else
    Form15.caption:=caption;
  with Form15 do Begin
    bok.Show;
    babbrechen.Show;
    label1.Show;
    label1.Caption:=ueberschrift;
    label2.hide;
    edit1.show;
    edit1.text:=eing;
    edit2.hide;
    memo1.top:=edit1.top+edit1.height+20;
    Height:=screen.Height*3 div 4;
    memo1.height:=height-memo1.top-40;
    TextinMemo(Erlaeuterung);
    showmodal;
    result:=ok;
    if Ok then BEgin
      eing:=edit1.text;
    ENd;
  End;
  Finally form15.Free End;
end;

function jminput2(const caption,ueberschrift1,ueberschrift2,Erlaeuterung:string;
                   var eing1,eing2:string):boolean;
begin
  form15:=Tform15.Create(Form9);
  try
  if caption='' then Form15.caption:='Eingabe' else
    Form15.caption:=caption;
  with Form15 do Begin
    bok.Show;
    babbrechen.Show;
    label1.Show;
    label1.Caption:=ueberschrift1;
    label2.Show;
    label2.Caption:=ueberschrift2;
    edit1.show;
    edit1.text:=eing1;
    edit2.show;
    edit2.text:=eing2;
    memo1.top:=edit2.top+edit2.height+20;
    Height:=screen.Height*3 div 4;
    memo1.height:=height-memo1.top-40;
    TextinMemo(Erlaeuterung);
    showmodal;
    result:=ok;
    if Ok then BEgin
      eing1:=edit1.text;
      eing2:=edit2.text;
    ENd;
  End;
  Finally form15.Free End;
end;

procedure TForm15.BOkClick(Sender: TObject);
  var n:integer;
begin
  ok:=true;
  for n:=0 to length(buttons)-1 do
   if sender as Tbutton = buttons[n] then ButtonsNr:=n;
  close;
end;

procedure TForm15.BAbbrechenClick(Sender: TObject);
begin
  Ok:=false;
  close;
end;

procedure TForm15.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then if edit2.Visible then edit2.SetFocus else
     BOkClick(Nil);
end;

procedure TForm15.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
   if key=#13 then BOkClick(Nil);
end;

procedure TForm15.FormDestroy(Sender: TObject);
  var n:integer;
begin
  for n:=0 to length(buttons)-1 do buttons[n].free;
  setlength(buttons,0);
  //BAbbrechen.left:=Bok.left+Bok.width+20;
end;


procedure TForm15.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#27 then BAbbrechenClick(Sender);
end;

end.
