unit Unit2ww;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, OleCtrls, SHDocVw, ExtCtrls, Menus;

type
  TForm2 = class(TForm)
    ComboBox1: TComboBox;
    WebBrowser1: TWebBrowser;
    procedure ComboBox1DblClick(Sender: TObject);
    procedure WebBrowser1StatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure WebBrowser1NewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure WebBrowser1BeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure WebBrowser1DocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure WebBrowser1ProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure WebBrowser1TitleChange(Sender: TObject;const Text: WideString);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    UrlGelesen :string; //Falls Datei von Festplatte, kann Sie gelscht werden
    { Public-Deklarationen }
  end;

const  KeineSeiteppp = 'Keine Seite zum Anzeigen';
var Form2aktiv: TForm2;  //Der einzige "Ansprechpartner"
procedure FindAddress(url:string);
procedure NeueUrl(const url:string);

implementation
  {$R *.DFM}
uses  activeX,
      unit1ww,   //wg TTWIniFile
      WINSOCK, //wg IP
      ComObj,  //wegen Ole
      inifiles;

procedure historyAdd(const s:string);
  var k:integer;
begin
  for k:=0 to history.Count-1 do if s=history[k] then exit; //schon drin
  history.Insert(0,s);
  while history.count>historymax do history.Delete(history.count-1); //Beschrnkung
end;

procedure NeueUrl(const url:string);
begin
  if url = temphtml then exit;
  historyAdd(url);
  form2aktiv.ComboBox1.Text:=url;
  form2aktiv.ComboBox1.SelectAll;
end;

procedure FindAddress(url:string);  //Siehe Borlan/Delphi5/Demos/Coolstuff
begin
if form2Aktiv=nil then exit;
  form2Aktiv.urlgelesen := url;
  form2Aktiv.WebBrowser1.Navigate(WideString(url)); //Ohne flag = 0 Olevariant
  NeueUrl(url);
end;


procedure TForm2.ComboBox1DblClick(Sender: TObject);
begin
 form2Aktiv:=(sender as TControl).parent as TForm2;
 findAddress(combobox1.Text);
end;

procedure TForm2.WebBrowser1StatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  form1.StatusBar1.SimpleText :=text;
  if pos('//',text)>0 then AlterStatusbarText:=text;
end;

procedure TForm2.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
 form2Aktiv:=(sender as TControl).parent as TForm2;
 if key=#13 then findAddress(combobox1.Text);
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
  form2Aktiv:=Sender as TForm2;
end;

procedure TForm2.WebBrowser1NewWindow2(Sender: TObject;
     var ppDisp: IDispatch; var Cancel: WordBool);
  var c:integer;
      url:string;
      s:string;
begin
  url:=form1.StatusBar1.SimpleText; //Aktueller browser
  if pos('//',url)<>1 then url:=AlterStatusbarText;
  if url='' then s:=#13#10+'---------------------------------'#13#10+
                           'Hier nur mglich:"IE" oder "nicht"'#13#10+
                           '(Wahrscheinlich ein Werbebanner)';
  c:=frage(url,
           'IE','TTWEB','hier','nicht',
           'Es wird ein neues Fenster verlangt'#13#10+
           '====== '+url+' ======================'#13#10+
           'IE    : Intenetexplorer aufrufen'#13#10+       //c=0
           'TTTWEB: TTWEB ffnet ein neues Fenster'#13#10+ //  1
           'hier  : Im Fenster hier laden'#13#10+          //  2
           'nicht : Die Adresse wird nicht geladen'+       //  3
           s);
  if c=0 then cancel:=false //Internetexplorer
  else Begin
    cancel:=true;  //Keinen Internetexplorer
    if url='' then exit;
    if c=2 then FindAddress(url)
      else if c=1 then ErzeugeForm2Aktiv(url);
    //sonst c=3 gar nicht
  End;
end;

procedure TForm2.WebBrowser1BeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
begin
    //NeueUrl(url);
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
  var k:integer;
begin
  for k := 0 to length(Form2) - 1 do
    if form2aktiv = Form2[k] then Begin
      form2[k] := nil;
      form1.TabControl1.Tabs[k] := '-';
    End;
  action:=caFree;
  form2Aktiv := nil;
  BaueTabcontrol;
end;

procedure TForm2.WebBrowser1DocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
 NeueUrl(url);
end;

function copyab(const s:string; const i:integer):string;  //Rest von s ab i. em Zeichen
  begin result:=copy(s,i,length(s)-i+1) end;

procedure TForm2.WebBrowser1ProgressChange(Sender: TObject; Progress,
                                           ProgressMax: Integer);
  var proz:integer;
      s: string;
begin
 if Progressmax<10 then exit;
 proz:=progress*100 div ProgressMax;
  with  form1.StatusBar1 do
    if (proz>2) and (proz<98) then Begin
      if pos('%',simpletext)>0 then s:=copyab(simpletext,pos('%',simpletext)+1)
        else s:=simpletext;
      simpletext:=IntToStr(proz)+'%|'+s;
    End;
end;

function OhnePunkt(const s:string):string;
begin
  result := s;
  while result>'' do Begin
    if result[length(result)] <> '.' then exit;
    result := copy(result,1,length(result)-1)
  End;
end;

procedure TForm2.WebBrowser1TitleChange(Sender: TObject;  const Text: WideString);
  var k,n :integer;
      s :string;
begin
  form1.Caption:=text;
  if text = KeineSeiteppp then  s := '.' else
    if (length(form2)>4) and (length(text)>20) then s := copy(text,1,20) + '..' else s := text;
  for k := 0 to length(form2) - 1 do
    if form2aktiv = form2[k] then Begin
      form1.TabControl1.Tabs[k] := s;
      ueberschrift[k] := text;
    End;
  n := 20 - length(form2);
  if n < 5 then n := 5;
  if n < 20 then for k := 0 to length(form2)-1 do
    form1.TabControl1.Tabs[k] := copy(OhnePunkt(form1.TabControl1.Tabs[k]),1,n)+'..';
end;

procedure TForm2.FormKeyPress(Sender: TObject; var Key: Char);
begin
   if key = #27 then Form1.Zurck1Click(Nil);
end;

initialization
  OleInitialize(nil);

finalization
  OleUninitialize;
end.

