unit Unit3ww;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, WinSpool;

type
  TForm3 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    BBrowserStarten: TButton;
    BOk: TButton;
    Bgross: TButton;
    BSpeichern: TButton;
    BEinlesen: TButton;
    BAbbruch: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    BDrucken: TButton;
    procedure FormActivate(Sender: TObject);
    procedure BBrowserStartenClick(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
    procedure BOkClick(Sender: TObject);
    procedure BgrossClick(Sender: TObject);
    procedure BSpeichernClick(Sender: TObject);
    procedure BEinlesenClick(Sender: TObject);
    procedure BAbbruchClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BDruckenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    form3Adresse:string;
    { Public-Deklarationen }
  end;

var
  Form3: TForm3;

implementation
uses  Menus,
      unit2ww, Unit1ww;
{$R *.DFM}

procedure TForm3.FormActivate(Sender: TObject);
begin
  if form2aktiv=nil then Form1.neu1Click(nil);
  setbounds(200,50,500,screen.height-70);
end;

function ZeileDesCursorsI(ed:TCustomEdit):integer;
    var k:integer;
        s:string;
  begin s:=ed.Text; //ohne schafft es der Compiler nicht
        result:=1;
        for k:=1 to ed.Selstart do
        if s[k]=#13 then inc(result);
  end;


function ZeileDesCursorsS(ed:TCustomMemo):string;
    var i:integer;
  begin i:=ZeileDesCursorsI(ed)-1;
        if ed.Lines.count>i then result:=ed.lines[i] else result:='';
  end;


procedure TForm3.BBrowserStartenClick(Sender: TObject);
begin
  findAddress(form2aktiv.combobox1.Text);
  close;
end;

procedure TForm3.Memo1Click(Sender: TObject);
  var s:string;
begin
  s:=ZeileDesCursorsS(memo1);
  if s=MenuHilfe then form1.Hilfe1Click(Nil) else
    if (pos('.',s)>0) and not form3.memo1.readonly
      then form2aktiv.ComboBox1.text:=s;
end;

procedure TForm3.BOkClick(Sender: TObject);
begin
  close
end;

procedure TForm3.BgrossClick(Sender: TObject);
begin
  form3.SetBounds(30,30,700,500);
end;

procedure TForm3.BSpeichernClick(Sender: TObject);
begin
   with SaveDialog1 do Begin
     Initialdir:=extractFilepath(form3Adresse);
     filename:=extractFilename(form3Adresse);
     if execute then
       memo1.Lines.SaveToFile(Filename);
   End;
end;

procedure TForm3.BEinlesenClick(Sender: TObject);
begin
   with OpenDialog1 do Begin
     Initialdir:=extractFilepath(form3Adresse);
     filename:=extractFilename(form3Adresse);
     if execute then
       memo1.Lines.loadfromFile(Filename);
   End;
end;

procedure TForm3.BAbbruchClick(Sender: TObject);
begin
  memo1.Lines.Clear;
  close;
end;
procedure neben(neu,alt:Twincontrol);
begin
 neu.top := alt.top;
 neu.Height := alt.height;
 neu.Left:=alt.left+alt.Width;
end;


procedure TForm3.FormCreate(Sender: TObject);
begin
  BBrowserStarten.left:=0;
  BBrowserStarten.top := 0;
  BBrowserStarten.height := panel1.Height;
  neben(bok,BBrowserStarten);
  neben(babbruch,Bok);
  neben(Bgross,babbruch);
  neben(BSpeichern,Bgross);
  neben(BEinlesen,BSpeichern);
  neben(BDrucken,BEinlesen);
end;


procedure DruckeRoh_String(DiesenText:string); //uses WinSpool;

var Printer : array [0..255] of char;
    p       : Integer;

  function RawDataToPrinter(const szPrinterName : string;
                            const data:string; 
                            dwCount : DWORD) : boolean;
  var
    hPrinter       : THandle;
    DocInfo        : TDocInfo1;
    dwJOB          : DWORD;
    dwBytesWritten : DWORD;
  begin
    Result := False;
    if OpenPrinter (pchar (szPrinterName), hPrinter, Nil) then
      try
        // Fill in the structure with info about this "document"
        DocInfo.pDocName := 'My Document';
        DocInfo.pOutputFile := Nil;
        DocInfo.pDatatype := 'RAW';
        // Inform the spooler the document is beginning
        dwJob := StartDocPrinter (hPrinter, 1, @docInfo);
        if dwJob <> 0 then
          try
            if StartPagePrinter (hPrinter) then
              try
                if WritePrinter (hPrinter, Pchar(data), dwCount, dwBytesWritten) then
                  Result := dwBytesWritten = dwCount;
              finally
                EndPagePrinter (hPrinter)
              end
          finally
            EndDocPrinter (hPrinter);
          end
      finally
        ClosePrinter (hPrinter)
      end
  end; {RawDataToPrinter}

begin
  GetProfileString ('windows',
                    'device',
                    ',,,',
                    Printer,
                    sizeof(Printer));
  p := Pos (',', Printer);
  if p > 0 then
    Printer [p - 1] := #0;
  RawDataToPrinter (Printer, DiesenText, length(DiesenText));
end; {Joachim Mohr}


procedure TForm3.BDruckenClick(Sender: TObject);
begin
  DruckeRoh_String(memo1.text+#12);
end;

end.
